********************************************************************************
******************** COMPUTATION OF RANDOM COUPLES *****************************
********************************************************************************

clear all
set more off
cap log close


*** I create 10 random samples but always match spouses within oblasts 
*** I then build a dataset of all 10 random samples and calculate the similarity indexes for them 



*** Random sample no. 1 

use "C:\Replication\wifes.dta", clear


* How are couple IDs distributed across oblasts?
sum couple_id if oblast == 2			// Issyk Kul: 1-221
sum couple_id if oblast == 3			// Jalal Abad: 222-759
sum couple_id if oblast == 4			// Naryn: 760-868
sum couple_id if oblast == 5			// Batken: 869-1146
sum couple_id if oblast == 6			// Osh: 1147-1844
sum couple_id if oblast == 7			// Talas: 1845-1971
sum couple_id if oblast == 8			// Chui: 1972-2351
sum couple_id if oblast == 11			// Bishkek: 2352-2667
sum couple_id if oblast == 21			// Osh city: 2668-2812


* randomly order the wives and assign them new couple_IDs
set seed 6543

gen double u = runiform()					// draw without replacement
sort oblast u

gen couple_id_new = _n
rename couple_id couple_id_old
rename couple_id_new couple_id 
sort couple_id 
gen test = (couple_id_old == couple_id)
tab test 
// 9 observations for which the old couple ID is identical with the new couple ID
drop test


* match these women with husbands 

merge 1:1 couple_id using "C:\Replication\husbands.dta"
drop _m
rename couple_id couple_id1

save "C:\Replication\final_random1.dta", replace



*** Random sample no. 2 

use "C:\Replication\wifes.dta", clear

* randomly order the wifes and assign them new couple_IDs
set seed 1865

gen double u = runiform()					// draw without replacement
sort oblast u

gen couple_id_new = _n
rename couple_id couple_id_old
rename couple_id_new couple_id 
sort couple_id 
gen test = (couple_id_old == couple_id)
tab test 
// 11 observations for which the old couple ID is identical with the new couple ID
drop test

* match these women with husbands 
merge 1:1 couple_id using "C:\Replication\husbands.dta"
drop _m
rename couple_id couple_id2

save "C:\Replication\final_random2.dta", replace



*** Random sample no. 3 

use "C:\Replication\wifes.dta", clear

* randomly order the wifes and assign them new couple_IDs
set seed 6296

gen double u = runiform()					// draw without replacement
sort oblast u

gen couple_id_new = _n
rename couple_id couple_id_old
rename couple_id_new couple_id 
sort couple_id 
gen test = (couple_id_old == couple_id)
tab test 
// 6 observations for which the old couple ID is identical with the new couple ID
drop test

* match these women with husbands 
merge 1:1 couple_id using "C:\Replication\husbands.dta"
drop _m
rename couple_id couple_id3

save "C:\Replication\final_random3.dta", replace




*** Random sample no. 4 

use "C:\Repication\wifes.dta", clear

* randomly order the wifes and assign them new couple_IDs
set seed 7777

gen double u = runiform()					// draw without replacement
sort oblast u

gen couple_id_new = _n
rename couple_id couple_id_old
rename couple_id_new couple_id 
sort couple_id 
gen test = (couple_id_old == couple_id)
tab test 
// 9 observations for which the old couple ID is identical with the new couple ID
drop test

* match these women with husbands 
merge 1:1 couple_id using "C:\Replication\husbands.dta"
drop _m
rename couple_id couple_id4

save "C:\Replication\final_random4.dta", replace




*** Random sample no. 5

use "C:\Replication\wifes.dta", clear

* randomly order the wifes and assign them new couple_IDs
set seed 9253

gen double u = runiform()					// draw without replacement
sort oblast u

gen couple_id_new = _n
rename couple_id couple_id_old
rename couple_id_new couple_id 
sort couple_id 
gen test = (couple_id_old == couple_id)
tab test 
// 14 observations for which the old couple ID is identical with the new couple ID
drop test

* match these women with husbands 
merge 1:1 couple_id using "C:\Replication\husbands.dta"
drop _m
rename couple_id couple_id5

save "C:\Replication\final_random5.dta", replace



*** Random sample no. 6

use "C:\Replication\wifes.dta", clear

* randomly order the wifes and assign them new couple_IDs
set seed 6853

gen double u = runiform()					// draw without replacement
sort oblast u

gen couple_id_new = _n
rename couple_id couple_id_old
rename couple_id_new couple_id 
sort couple_id 
gen test = (couple_id_old == couple_id)
tab test 
// 4 observations for which the old couple ID is identical with the new couple ID
drop test

* match these women with husbands 
merge 1:1 couple_id using "C:\Replication\husbands.dta"
drop _m
rename couple_id couple_id6

save "C:\Replication\final_random6.dta", replace



*** Random sample no. 7

use "C:\Replication\wifes.dta", clear

* randomly order the wifes and assign them new couple_IDs
set seed 9154

gen double u = runiform()					// draw without replacement
sort oblast u

gen couple_id_new = _n
rename couple_id couple_id_old
rename couple_id_new couple_id 
sort couple_id 
gen test = (couple_id_old == couple_id)
tab test 
// 8 observations for which the old couple ID is identical with the new couple ID
drop test

* match these women with husbands 
merge 1:1 couple_id using "C:\Replication\husbands.dta"
drop _m
rename couple_id couple_id7

save "C:\Replication\final_random7.dta", replace



*** Random sample no. 8 

use "C:\Replication\wifes.dta", clear

* randomly order the wifes and assign them new couple_IDs
set seed 1936

gen double u = runiform()					// draw without replacement
sort oblast u

gen couple_id_new = _n
rename couple_id couple_id_old
rename couple_id_new couple_id 
sort couple_id 
gen test = (couple_id_old == couple_id)
tab test 
// 8 observations for which the old couple ID is identical with the new couple ID
drop test

* match these women with husbands 
merge 1:1 couple_id using "C:\Replication\husbands.dta"
drop _m
rename couple_id couple_id8

save "C:\Replication\final_random8.dta", replace



*** Random sample no. 9 

use "C:\Replication\wifes.dta", clear

* randomly order the wifes and assign them new couple_IDs
set seed 9255

gen double u = runiform()					// draw without replacement
sort oblast u

gen couple_id_new = _n
rename couple_id couple_id_old
rename couple_id_new couple_id 
sort couple_id 
gen test = (couple_id_old == couple_id)
tab test 
// 11 observations for which the old couple ID is identical with the new couple ID
drop test

* match these women with husbands 
merge 1:1 couple_id using "C:\Replication\husbands.dta"
drop _m
rename couple_id couple_id9

save "C:\Replication\final_random9.dta", replace



*** Random sample no. 10 

use "C:\Replication\wifes.dta", clear

* randomly order the wifes and assign them new couple_IDs
set seed 9999

gen double u = runiform()					// draw without replacement
sort oblast u

gen couple_id_new = _n
rename couple_id couple_id_old
rename couple_id_new couple_id 
sort couple_id 
gen test = (couple_id_old == couple_id)
tab test 
// 11 observations for which the old couple ID is identical with the new couple ID
drop test

* match these women with husbands 
merge 1:1 couple_id using "C:\Replication\husbands.dta"
drop _m
rename couple_id couple_id10

save "C:\Replication\final_random10.dta", replace



append using "C:\Replication\final_random1.dta"
append using "C:\Replication\final_random2.dta"
append using "C:\Replication\final_random3.dta"
append using "C:\Replication\final_random4.dta"
append using "C:\Replication\final_random5.dta"
append using "C:\Replication\final_random6.dta"
append using "C:\Replication\final_random7.dta"
append using "C:\Replication\final_random8.dta"
append using "C:\Replication\final_random9.dta"


* create new couple ID variable that counts all couples through 
gen couple_random_id = _n
drop couple_id1 couple_id2 couple_id3 couple_id4 couple_id5 couple_id6 couple_id7 couple_id8 couple_id9 couple_id10 couple_id_old
save "C:\Replication\final_random_all.dta", replace


* calculate duration of marriage
gen dur_marr = w_age - age_marr_wife
tab dur_marr


* calculate schooling years and difference in schooling between husband and wife
gen h_school = 0 if h_education == 1
replace h_school = 3 if h_education == 2
replace h_school = 8 if h_education == 3
replace h_school = 10 if h_education == 4
replace h_school = 11 if h_education == 5
replace h_school = 13 if h_education == 6
replace h_school = 15 if h_education == 7
replace h_school = 18 if h_education == 8

gen w_school = 0 if w_education == 1
replace w_school = 3 if w_education == 2
replace w_school = 8 if w_education == 3
replace w_school = 10 if w_education == 4
replace w_school = 11 if w_education == 5
replace w_school = 13 if w_education == 6
replace w_school = 15 if w_education == 7
replace w_school = 18 if w_education == 8



save "C:\Replication\final_random_all.dta", replace


********************************************************************************
**** build similarity index



*** PERSONALITY

*** 1) Profile similarity index (varies from -1 to 1)
// can only be calculated for those couples without any missing values

use "C:\Replication\final_random_all.dta", clear

keep couple_random_id oblast interview h_pers1-h_pers21 type_marr w_pers1- w_pers21 dur_marr
sort couple_random_id


* How many couples have missing values?
forvalues i = 1(1)21 {
		gen missing_w`i' = (w_pers`i' == .)
		}

forvalues i = 1(1)21 {
		gen missing_h`i' = (h_pers`i' == .)
		}

gen sum_miss_w = missing_w1 + missing_w2 + missing_w3 + missing_w4 + missing_w5 + missing_w6 + missing_w7 + missing_w8 + missing_w9 + missing_w10 + missing_w11 + missing_w12 + missing_w13 + missing_w14 + missing_w15 + missing_w16 + missing_w17 + missing_w18 + missing_w19 + missing_w20 + missing_w21
gen sum_miss_h = missing_h1 + missing_h2 + missing_h3 + missing_h4 + missing_h5 + missing_h6 + missing_h7 + missing_h8 + missing_h9 + missing_h10 + missing_h11 + missing_h12 + missing_h13 + missing_h14 + missing_h15 + missing_h16 + missing_h17 + missing_h18 + missing_h19 + missing_h20 + missing_h21

gen nomiss = (sum_miss_w == 0 & sum_miss_h == 0)
replace nomiss = . if sum_miss_w == . | sum_miss_h == . 
tab nomiss, m
tab nomiss if type_marr != .
tab nomiss if type_marr != ., m


// among our 25,200 couples, for 1,819 we have no information on all wife's personality items, husband's personality items or both - they did not respond to the module
// 23,381 couples have no missing value at all; we can calculate the profile similarity index only for them


* I drop all couples that have any missing values 
forvalues i = 1(1)21 {
	drop if h_pers`i' == . 
	rename h_pers`i' pers`i'_0
	}

forvalues i = 1(1)21 {
	drop if w_pers`i' == . 
	rename w_pers`i' pers`i'_1
	}


reshape long pers1_ pers2_ pers3_ pers4_ pers5_ pers6_ pers7_ pers8_ pers9_ pers10_ pers11_ pers12_ pers13_ pers14_ pers15_ pers16_ pers17_ pers18_ pers19_ pers20_ pers21_, i(couple_random_id) j(wife)  
 label drop _all
label def wife 1 "wife" 0 "husband"
label val wife wife


*** are the observations always couples?
sort couple_random_id wife
by couple_random_id: gen number = _N
tab number 								// all have number = 2; only couples included!


forvalues i = 1(1)21 {
	rename pers`i'_ pers`i'
	}

	
quietly generate double corr = .

tempname M
forvalues row = 1(2)`=_N' {

     matrix dissimilarity `M' = pers1 - pers21 if inlist(_n, `row', `row'+1), correlation
     quietly replace corr = `M'[2, 1] in `row'
}

rename corr corr_pers_profile

tab corr_pers_profile if corr_pers_profile < -0.9 
// no cases with value -1
tab corr_pers_profile if corr_pers_profile > 0.9 
// 25 cases with value +1; these seem to be unproblematic

gen help_pers = (corr_pers_profile == 1 | corr_pers_profile == -1)
tab help_pers
// 25 are recognised; no corrections needed

sum corr_pers_profile

drop if wife == 1
sort couple_random_id

save "C:\Replication\sim_pers_profile_random.dta", replace


count if corr_pers_profile!= . & type_marr != .
// 23,381 

exit


